#!/usr/bin/perl
require 5.6.0;
use strict;
use lib './lib';
#-------------------------------------------------------------------------------
# Satsuki system - Startup routine (for FastCGI)
#			Copyright (C)2005-2006 nabe@abk / E-mail:nabe@abk.nu
#-------------------------------------------------------------------------------
# Last Update : 2006/07/25

#--------------------------------------------------
# FastCGI メインループ
#--------------------------------------------------
use FCGI;
my $request = FCGI::Request();
while($request->Accept() >= 0) {
	#--------------------------------------------------
	# 時間計測開始
	#--------------------------------------------------
	require Satsuki::Timer;
	my $timer = Satsuki::Timer->new();
	$timer->start();
	#--------------------------------------------------
	# メイン
	#--------------------------------------------------
	require Satsuki::Base;			# ベースシステム（標準関数）ロード
	my $ROBJ = Satsuki::Base->new();	# ルートオブジェクト生成
	$ROBJ->{Timer} = $timer;		# タイマーの保存

	#--------------------------------------------------
	# FastCGI向け リロードチェック
	#--------------------------------------------------
	$ROBJ->init_for_fastcgi($request, 'Satsuki::');

	#--------------------------------------------------
	# メイン
	#--------------------------------------------------
	eval { $ROBJ->start_up(); };
	if ($ROBJ->{FastCGI_LastRequest}) { last; }

	undef %$ROBJ;		# メモリリーク対策（必須）
}
