#!/usr/local/bin/perl
require 5.004;
use strict;
#-------------------------------------------------------------------------------
# Split from Satsuki::Diary.pm for AUTOLOAD.
#-------------------------------------------------------------------------------
use Satsuki::Diary ();
use Satsuki::Diary_auto ();
use Satsuki::Diary_auto2 ();
package Satsuki::Diary;
our $DAYBOOKLIST_TABLE;
###############################################################################
# Ըǽ
###############################################################################
#------------------------------------------------------------------------------
# ٤ƤĢ°ƹ
#------------------------------------------------------------------------------
sub root_daybooks_info_rebuild {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $auth = $ROBJ->{Auth};
	if (! $auth->{admin}) { $ROBJ->message('Operation not permitted'); return 5; }

	my $daybooks = $DB->select($DAYBOOKLIST_TABLE, {no_error => 1});
	foreach (@$daybooks) {
		my $diary_id = $_->{id};
		$self->generate_category_list   ( $diary_id );
		$self->generate_recent_diary    ( $diary_id );
		$self->generate_recent_comment  ( $diary_id );
		$self->generate_recent_trackback( $diary_id );
	}
	$self->{daybooks} = $#$daybooks +1;
	return 0;
}

###############################################################################
# ĢκȺ
###############################################################################
#------------------------------------------------------------------------------
# Ģ
#------------------------------------------------------------------------------
sub daybook_create {
	my ($self) = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $auth = $ROBJ->{Auth};
	my $id   = $auth->{id};
	if (! $auth->{ok})              { $ROBJ->message('Not login'); return 1; }
	if ($self->{exsits_my_daybook}) { $ROBJ->message('The daybook has already existed'); return 10; }

	# ǡ١ơ֥
	my $r = $self->create_tables($id);
	if ($r) {
		$ROBJ->message('Daybook create failed');
		$self->drop_tables($id);
	} else {
		# ɸΥԡ
		my $set  = $self->load_daybook_setting( '' );	# ǥեȥ
		my $file = $self->{setting_dir} . $id . $self->{file_ex};
		$ROBJ->mkdir( $self->{setting_dir} );
		$ROBJ->fwrite_hash( $file, $set );		# 
	}
	return $r;
}

#------------------------------------------------------------------------------
# ǤդĢʴѡ
#------------------------------------------------------------------------------
sub root_daybook_create {
	my ($self, $id) = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $auth = $ROBJ->{Auth};
	if (! $auth->{admin}) { $ROBJ->message('Operation not permitted'); return 5; }

	# ĢIDå
	if ($id =~ /[^a-z0-9_]/ || $id !~ /^[a-z]/) {
		$ROBJ->message("Can't allow character used"); return 9;
	}
	if ($DB->find_table("${id}_diary")) {
		$ROBJ->message('The daybook has already existed'); return 10;
	}

	# ǡ١ơ֥
	my $r = $self->create_tables($id);
	if ($r) {
		$ROBJ->message('Daybook create failed');
		$self->drop_tables($id);
	} else {
		# ɸΥԡ
		my $set  = $self->load_daybook_setting( '' );	# ǥեȥ
		my $file = $self->{setting_dir} . $id . $self->{file_ex};
		$ROBJ->mkdir( $self->{setting_dir} );
		$ROBJ->fwrite_hash( $file, $set );		# 
	}
	return $r;
}

#------------------------------------------------------------------------------
# Ģκ
#------------------------------------------------------------------------------
sub daybook_drop {
	my ($self) = @_;
	my $ROBJ     = $self->{ROBJ};
	my $auth     = $ROBJ->{Auth};
	my $diary_id = $self->{diary_id};
	if (! $auth->{ok}) { $ROBJ->message('Not login');   return 1; }
	if (! $self->{daybook_admin}) { $ROBJ->message('Operation not permitted'); return 5; }

	my $r = $self->drop_tables($diary_id);
	if ($r) { $ROBJ->message('Daybook delete failed'); return $r; }

	# ѿν
	undef $self->{exsits_daybook};
	if ($auth->{id} eq $diary_id) { undef $self->{exsits_my_daybook}; }
	$self->{allow_edit}    = undef;
	$self->{allow_com}     = undef;
	$self->{daybook_admin} = undef;

	# Ģ եκ
	$ROBJ->file_delete($self->{setting_dir} . $diary_id . $self->{file_ex});
	$ROBJ->file_delete($self->{usercss_dir} . $diary_id . $self->{file_ex});

	# archive files / κ
	$ROBJ->dir_delete( $self->{archive_dir} . $diary_id . '/' );
	return 0;
}
###############################################################################
# ǡ١ߥ֥롼
###############################################################################
#------------------------------------------------------------------------------
# ơ֥κ
#------------------------------------------------------------------------------
sub create_tables {
	my ($self, $table) = @_;

	my @text_cols    = qw(title category category_main name id text _text parser ip host agent files);
	my @num_cols     = qw(tm yyyymmdd comments comments_all tbs tbs_all update_tm priority upnode);
	my @flag_cols    = qw(enable allow_hcom allow_com allow_tb disp_ref);
	my @idx_cols     = qw(tm yyyymmdd title category category_main name id enable priority upnode);
	my @unq_cols     = qw();
	my @notnull_cols = qw(enable title name text _text tm yyyymmdd priority);
	my %ref_cols     = ();
	my $diary_table  = $table . '_diary';
	my $r = $self->_do_crate_table($diary_table, \@text_cols, \@num_cols, \@flag_cols, \@idx_cols, \@unq_cols, \@notnull_cols, \%ref_cols);
	if ($r) { return 100 + $r; }

	@text_cols    = qw(name id text text_short email url pass ip host agent diary_title);
	@num_cols     = qw(tm diary_pkey diary_yyyymmdd);
	@flag_cols    = qw(enable hidden);
	@idx_cols     = qw(tm diary_pkey name id enable hidden diary_yyyymmdd ip);
	@unq_cols     = qw();
	@notnull_cols = qw(enable name text text_short tm diary_pkey);
	%ref_cols     = (diary_pkey => "$diary_table.pkey");
	$r = $self->_do_crate_table("${table}_comment", \@text_cols, \@num_cols, \@flag_cols, \@idx_cols, \@unq_cols, \@notnull_cols, \%ref_cols);
	if ($r) { return 200 + $r; }

	@text_cols    = qw(title excerpt url blog_name author ip host agent diary_title);
	@num_cols     = qw(tm diary_pkey diary_yyyymmdd);
	@flag_cols    = qw(enable);
	@idx_cols     = qw(tm diary_pkey enable diary_yyyymmdd ip blog_name);
	@unq_cols     = qw();
	@notnull_cols = qw(enable tm diary_pkey);
	%ref_cols     = (diary_pkey => "$diary_table.pkey");
	$r = $self->_do_crate_table("${table}_tb", \@text_cols, \@num_cols, \@flag_cols, \@idx_cols, \@unq_cols, \@notnull_cols, \%ref_cols);
	if ($r) { return 300 + $r; }

	# ĢꥹȤϿ
	$self->insert_daybooklist($table);

	return 0;
} # End of create_tanble

sub _do_crate_table {
	my $self = shift;
	my $DB   = $self->{ROBJ}->{DB};
	my ($table, $text_cols, $num_cols, $flag_cols, $idx_cols, $unq_cols, $notnull_cols, $ref_cols) = @_;
	my %cols;
	foreach(@$flag_cols)    { $cols{$_} = {name => $_, type => 'flag'}; }	# 
	foreach(@$text_cols)    { $cols{$_} = {name => $_, type => 'text'}; }	# ƥ
	foreach(@$num_cols)     { $cols{$_} = {name => $_, type => 'int'};  }	# 
	foreach(@$idx_cols)     { $cols{$_}->{index}    = 1; }			# index
	foreach(@$unq_cols)     { $cols{$_}->{unique}   = 1; }			# unique
	foreach(@$notnull_cols) { $cols{$_}->{not_null} = 1; }			# NOT NULLe
	while(my ($k, $v) = each(%$ref_cols)) {			# 
		$cols{$k}->{ref_pkey} = $v;
	}
	my @cols;
	while(my ($k,$v) = each(%cols)) { push(@cols, $v); }
	return $DB->create_table("$table", \@cols);	# ơ֥κ
}

#------------------------------------------------------------------------------
# ơ֥κ
#------------------------------------------------------------------------------
sub drop_tables {
	my ($self, $table) = @_;
	my $DB = $self->{ROBJ}->{DB};

	my $r = 0;
	$r += $DB->drop_table("${table}_tb");
	$r += $DB->drop_table("${table}_comment");
	$r += $DB->drop_table("${table}_diary");

	# ĢꥹȤϿ
	$self->delete_daybooklist($table);

	return $r;
}

###############################################################################
# Ģơ֥
###############################################################################
#------------------------------------------------------------------------------
# Ģơ֥ɲ
#------------------------------------------------------------------------------
sub insert_daybooklist {
	my ($self, $diary_id) = @_;
	my $DB = $self->{ROBJ}->{DB};

	if (!$DB->find_table($DAYBOOKLIST_TABLE)) {
		my $r = $self->create_daybooklist_table();
		if ($r) { return 1; }		# error
	}

	my $ROBJ = $self->{ROBJ};
	my $auth = $ROBJ->{Auth};
	my %h;
	$h{timestamp} = $ROBJ->{Timestamp};
	$h{all_tm}    = $ROBJ->{TM};
	$h{id}        = $diary_id;

	#  = 0
	$h{diaries}  = $h{comments}   = $h{tbs}   = 0;
	$h{diary_tm} = $h{comment_tm} = $h{tb_tm} = 0;

	my $r  = $DB->insert($DAYBOOKLIST_TABLE, \%h);
	if (!$r) { return 2; }
	return 0;		# 
}

#------------------------------------------------------------------------------
# Ģơ֥뤫
#------------------------------------------------------------------------------
sub delete_daybooklist {
	my ($self, $diary_id) = @_;
	my $DB = $self->{ROBJ}->{DB};
	return $DB->delete_match($DAYBOOKLIST_TABLE, 'id', $diary_id);
}

#------------------------------------------------------------------------------
# ơ֥κ
#------------------------------------------------------------------------------
sub create_daybooklist_table {
	my ($self) = @_;
	my $DB = $self->{ROBJ}->{DB};

	#my @text_cols    = qw(id timestamp ip host agent);
	my @text_cols    = qw(id timestamp);
	my @num_cols     = qw(diaries comments tbs diary_tm comment_tm tb_tm all_tm);
	my @idx_cols     = qw(id diaries comments tbs diary_tm comment_tm tb_tm all_tm);
	my @unq_cols     = qw(id);
	my @notnull_cols = qw(id timestamp all_tm);
	return $self->_do_crate_table($DAYBOOKLIST_TABLE, \@text_cols, \@num_cols, [], \@idx_cols, \@unq_cols, \@notnull_cols, {});
}

###############################################################################
# ƹ۵ǽ
###############################################################################
# ꤷĢΤ٤Ƥƹ
#	 : ƹۤ
sub daybook_rebuild {
	my ($self, $diary_id) = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	$diary_id =~ s/\W//g;
	if (! $DB->find_table("${diary_id}_diary")) { $ROBJ->message('The daybook does not exist'); return 2; }

	#  diary_id ξ
	my @backup = ($self->{daybook_setting}, $self->{daybook_admin}, $self->{allow_edit}, $self->{myself}, $self->{myself2});
	$self->set_myself( $diary_id );
	$self->set_and_select_daybook( $diary_id );
	if (! $self->{daybook_admin}) {
		($self->{daybook_setting}, $self->{daybook_admin}, $self->{allow_edit}, $self->{myself}, $self->{myself2}) = @backup;
		$ROBJ->message('Operation not permitted'); return 5;
	}
	# ĥʳνԤ
	my $tag_escape;
	if ($self->{diary_allow_tags}) {
		$tag_escape = $ROBJ->loadpm('TextParser::TagEscape', $self->{diary_allow_tags});
		$tag_escape->{allow_anytag} = $self->{reliable_mode};
	}

	# 򤹤٤ƥ
	my $table = "${diary_id}_diary";
	my $logs  = $DB->select($table, {});
	my %parser_cache;
	my $success = 0;
	my @fail;
	foreach (@$logs) {
		my $pkey = $_->{pkey};
		#-------------------------------------------------------------
		# parser 
		#-------------------------------------------------------------
		my $parser = $_->{parser};
		$parser =~ s/\W//g;
		my $parser_obj = $parser_cache{$parser};
		if (!defined $parser_obj) {
			$self->{parser} = undef;
			$ROBJ->call( $self->{parser_skelton_dir} . $parser );
			$parser_obj = $self->{parser};
		}
		if (! ref($parser_obj)) {		# Ԥ exit
			if (! $parser_cache{$parser}) {
				$ROBJ->message("Load parser '%s' failed", $parser);
				$parser_cache{$parser} = -1;
			}
			push(@fail, $_);
			next;
		}
		$parser_cache{$parser} = $parser_obj;
		#-------------------------------------------------------------
		# parse
		#-------------------------------------------------------------
		my $yyyymmdd = $_->{yyyymmdd};
		$parser_obj->{thispkey} = $pkey;
		$parser_obj->{thisurl}  = $self->{myself2} . "0$pkey";
		$parser_obj->{thisyear} = substr($yyyymmdd, 0, 4);
		$parser_obj->{thismon}  = substr($yyyymmdd, 4, 2);
		$parser_obj->{thisday}  = substr($yyyymmdd, 6, 2);
		$parser_obj->{thistm}   = $_->{tm};
		$_->{text} = $parser_obj->text_parser( $_->{_text} );
		# ĥʳν
		if ($tag_escape) { $_->{text} = $tag_escape->escape($_->{text}); }
		#-------------------------------------------------------------
		# ̤¸
		#-------------------------------------------------------------
		my $r = $DB->update_match($table, $_, 'pkey', $pkey);
		if ($r) { $success += $r; }
		   else { push(@fail, $_); }
	}
	$self->{success} = $success;
	if (@fail) { $self->{fail} = \@fail; }
	($self->{daybook_setting}, $self->{daybook_admin}, $self->{allow_edit}, $self->{myself}, $self->{myself2}) = @backup;
	return 0;
}

###############################################################################
# ǡݡ
###############################################################################
sub diary_import {
	my ($self, $form) = @_;
	my $ROBJ = $self->{ROBJ};
	my $auth = $ROBJ->{Auth};
	if (! $auth->{ok})             { $ROBJ->message('Not login');                  return 1; }
	if (! $self->{exsits_daybook}) { $ROBJ->message('The daybook does not exist'); return 2; }
	if (! $self->{daybook_admin})  { $ROBJ->message('Operation not permitted');    return 5; }

	# ǡ
	my $type = $form->{type};
	if ($type eq '') {
		while(my ($k,$v) = each(%$form)) {
			# <input type="submit" name="type:ImportHatena" value="xxxǥݡ"> ؤб
			if ($k =~ /^type:/) { $type = substr($k, 5); }
		}
	}
	$type =~ s/\W//g;
	if (substr($type,0,6) ne 'Import') { $ROBJ->message('Data format error (%s)', -1); return -1; }
	my $importer;
	eval { $importer = $ROBJ->loadpm("Diary::$type"); };
	if ($@) { $ROBJ->message('Data format error (%s)', 0); return -2; }

	# ĥʳνԤ
	if ($self->{diary_allow_tags}) {
		$self->{tag_escape} = $ROBJ->loadpm('TextParser::TagEscape', $self->{diary_allow_tags});
		$self->{tag_escape}->{allow_anytag} = $self->{reliable_mode};
	}
	# եΥå
	if (! ref($form->{import}) || ! $form->{import}->{file_size}) {
		$ROBJ->message('Not selected file', 0); return -3;
	}
	# ǥեȥƥ
	my $category = $form->{category};
	$category =~ s/^\s*(.*?)\s*$/$1/;
	$category =~ s/\t/ /g;			# tabspaceִ
	if ($category eq '') { $category = $self->{default_category}; }
	#-------------------------------------------------------------
	# ݡȤμ¹
	#-------------------------------------------------------------
	$self->{form_default_category} = $category;
	$self->{force_category}        = $form->{force_category};
	$self->{force_author}          = $form->{force_author};
	$self->{no_import_comment}     = $form->{no_import_comment};
	$self->{no_import_trackback}   = $form->{no_import_trackback};
	my $r = $importer->import($self, $form);

	# ǶʤɤΡ
	my $diary_id = $self->{diary_id};
	$self->generate_recent_diary    ( $diary_id );
	$self->generate_recent_comment  ( $diary_id );
	$self->generate_recent_trackback( $diary_id );
	$self->generate_category_list   ( $diary_id );
	$self->generate_rss             ( $diary_id );

	return $r;
}

#------------------------------------------------------------------------------
# 򣱷¸
#------------------------------------------------------------------------------
# $self->save_diary(\%parser_cache, \%diary, \@comment, \@trackback);
# Ret:	0:  0ʳ:
#
# %parser_cache		ѡåѿʸƤӽФ¦Ѱա
#
# $diary->{enable}	1:ɽ 0:ɽԲ
# $diary->{year}	2000ǯ
# $diary->{mon}		112ʷ
# $diary->{day}		131
# $diary->{tm}		񤭹UTC
# $diary->{category}	ƥ
# $diary->{title}	ȥ
# $diary->{name}	ɮԡ$diary->{author} ǤϤʤΤա
# $diary->{text}	ʸʢɬܡ
# $diary->{parser}	ѡ
# $diary->{allow_com}	ȼդ  1:Yes 0:No
# $diary->{allow_tb}	Trackbackդ 1:Yes 0:No
# $diary->{priority}	ͥ, ١͡
# $diary->{upnode}	Ƶ
# $diary->{ip}		IPɥ쥹
# $diary->{host}	HOST̾
# $diary->{agent}	USER AGENT
#
# $c = $comment->[$n]	$n ܤν񤭹
# $c->{enable}		Ȥͭ 1:enable 0:disableʾά:1
# $c->{hidden}		ȡ   1: 0:   ʾά:0
# $c->{name}		̾ʢɬܡ
# $c->{text}		ʸʢɬܡ ̵Ԣ<br>Ѵ
# $c->{tm}		ȤƤ줿UTC
# $c->{email}		᡼륢ɥ쥹
# $c->{url}		URL
# $c->{ip}		IPɥ쥹(optional)
# $c->{host}		HOST̾(optional)
# $c->{agent}		USER AGENT(optional)
#
# $tb=$trackback->[$n]	$n ܤΥȥåХå
# $tb->{enable}		ȥåХåͭ 1:enable 0:disable
# $tb->{blog_name}	ȥåХåblog̾
# $tb->{title}		ȥåХåΥȥ
# $tb->{url}		ȥåХåURLʢɬܡ
# $tb->{tm}		TB줿UTC
# $tb->{author}		μɮ
# $tb->{excerpt}	  ̵
# $tb->{ip}		IPɥ쥹
# $tb->{host}		HOST̾
# $tb->{agent}		USER AGENT
#
# ϤɬפΤʤϤǤʤ˥Ǥϡ
# &gt; &lt; &quot;  < > " ᤹ɬפϤʤ
#
sub save_diary {
	my ($self, $parser_cache, $diary, $comments, $trackbacks) = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $auth = $ROBJ->{Auth};
	my $setting = $self->{daybook_setting};

	# ȡȥåХå򥤥ݡȤʤ
	if ($self->{no_import_comment})   { $comments   = []; }
	if ($self->{no_import_trackback}) { $trackbacks = []; }

	##############################################################
	# ǡ
	##############################################################
	# $x ||= 'data'  if (!$x) { $x='data'; } 
	my $now_tm = $ROBJ->{TM};
	$diary->{parser} ||= 'default_p1';
	$diary->{tm}     ||= $now_tm;
	$diary->{title}  ||= '(no title)';
	$diary->{name}   ||= $auth->{name};
	$diary->{id}       = $auth->{id};
	if ($self->{force_author}) { $diary->{name} = $auth->{name}; }
	# 
	foreach(@$comments) { $_->{tm} ||= $now_tm; }
	# ȥåХå
	foreach(@$trackbacks) {
		$_->{tm}    ||= $now_tm;
		$_->{title} ||= '(no title)';
	}

	##############################################################
	# ǡΥǡå
	##############################################################
	#-------------------------------------------------------------
	# դγǧ
	#-------------------------------------------------------------
	$diary->{tm} = int( $diary->{tm} );
	my $year = int( $diary->{year} );
	my $mon  = int( $diary->{mon}  );
	my $day  = int( $diary->{day}  );
	my $err = $self->check_date($year, $mon, $day);
	if ($err ne '') {	# 顼
		my $h = $ROBJ->time2timehash( $diary->{tm} );
		$year = $h->{year};
		$mon  = $h->{mon};
		$day  = $h->{day};
	}
	$diary->{yyyymmdd} = sprintf("%04d%02d%02d", $year, $mon, $day);
	my $error_head  = "[$diary->{yyyymmdd}/$diary->{tm}]";
	#-------------------------------------------------------------
	# ƥȷϤγǧ
	#-------------------------------------------------------------
	my $text = $diary->{text};
	$text =~ s/^(.*)\n*$/$1/;	# βԤ
	if ($text =~ /^\s*$/)  { $self->import_error($error_head, 'Main text is empty'); return 2; }

	# 
	$ROBJ->tag_escape($diary->{title}, $diary->{category}, $diary->{name}, $diary->{ip}, $diary->{host}, $diary->{agent});
	&delete_crlf($diary->{title}, $diary->{category}, $diary->{name}, $diary->{ip}, $diary->{host}, $diary->{agent}, $diary->{files});
	$ROBJ->uri_encode($diary->{files});
	#-------------------------------------------------------------
	# ƥβ
	#-------------------------------------------------------------
	my $category = $diary->{category};
	$category =~ s/^\s*(.*?)\s*$/$1/;	# ζ
	$category =~ s/\t/ /g;			# tabspaceִ
	if ($self->{force_category} || $category eq '') { $category = $self->{form_default_category}; }

	my ($category_main, $category_sub) = split(/\s*::\s*/, $category, 2);
	if ($category_sub eq '') { $category = $category_main; }
	$diary->{category}      = $category;
	$diary->{category_main} = $category_main;
	#-------------------------------------------------------------
	# ե饰å
	#-------------------------------------------------------------
	my @flags = qw(enable allow_com allow_hcom allow_tb disp_ref);
	foreach(@flags) {
		if (!defined $diary->{$_}) { $diary->{$_}=$setting->{$_}; }	# ̤ǥե
		if ($diary->{$_}) { $diary->{$_}=1; } else { $diary->{$_}=0; }
	}
	##############################################################
	# ѡ
	##############################################################
	my $parser = $diary->{parser};
	$parser =~ s/\W//g;
	my $parser_obj = $parser_cache->{$parser};
	if (! $parser_obj ) {
		$self->{parser} = undef;
		$ROBJ->call( $self->{parser_skelton_dir} . $parser );
		$parser_obj = $self->{parser};		# ɤѡΥ֥
		if (! ref($parser_obj)) {		# Ԥ exit
			$self->import_error($error_head, "Load parser '%s' failed", $parser);
			return 3;
		}
		$parser_cache->{$parser} = $parser_obj;
	}
	##############################################################
	# ɲý
	##############################################################
	my %insert;
	my $diary_id = $self->{diary_id};
	my @int_keys = qw(enable tm yyyymmdd disp_ref allow_com allow_hcom allow_tb);
	foreach(@int_keys) {
		if ($diary->{$_} ne '') { $insert{$_}=int($diary->{$_}); }
	}
	my @keys = qw(category category_main title name id ip host agent files);
	foreach(@keys) {
		if ($diary->{$_} ne '') { $insert{$_}=$diary->{$_}; }
	}
	$insert{text}      = '---this is dummy---';
	$insert{_text}     = '---this is dummy---';
	$insert{parser}    = $parser;
	$insert{update_tm} = $now_tm;
	$insert{comments}  = $insert{comments_all} = 0;
	$insert{tbs}       = $insert{tbs_all}      = 0;
	# 
	$insert{priority} = int( $diary->{priority} );
	$insert{upnode}   = int( $diary->{upnode}   );

	my $pkey = $DB->insert("${diary_id}_diary", \%insert);
	if (!$pkey) { $self->import_error($error_head, 'Diary post failed'); return 10; }
	#-------------------------------------------------------------
	# URL (diary_pkey) 塢ѡ̤ƽԤ
	#-------------------------------------------------------------
	my %update;
	$update{_text} = $text;		# ʸ
	if (ref($parser_obj) ne 'HASH') {
		$parser_obj->{thispkey} = $pkey;
		$parser_obj->{thisurl}  = $self->{myself2} . "0$pkey";
		$parser_obj->{thisyear} = $year;
		$parser_obj->{thismon}  = $mon;
		$parser_obj->{thisday}  = $day;
		$parser_obj->{thistm}   = $insert{tm};
		$text = $parser_obj->text_parser( $text );
	}
	# ĥʳν
	if ($self->{tag_escape}) {
		$text = $self->{tag_escape}->escape($text);
	}
	#-------------------------------------------------------------
	# Ƥ֤ʹ
	#-------------------------------------------------------------
	$update{text} = $text;
	my $r = $DB->update_match("${diary_id}_diary", \%update, 'pkey', $pkey);
	if (!$r) {
		$DB->delete_match("${diary_id}_diary", 'pkey', $pkey);
		$self->import_error($error_head, 'Diary post failed');
		return 12;
	}

	undef %update, $text;

	my $not_enable = (! $insert{enable});
	my $diary_yyyymmdd = $insert{yyyymmdd};
	my $diary_title    = $insert{title};
	undef %insert;

	my %info;
	##############################################################
	# Ȥν
	##############################################################
	$error_head = "[comment][$diary->{yyyymmdd}/$pkey]";
	foreach(@$comments) {
		my $text = $_->{text};
		my $name = $_->{name};
		$text =~ s/^(.*)\n*$/$1/;
		if ($text =~ /^\s*$/) { $self->import_error($error_head, 'Main text is empty'); next; }
		if ($name =~ /^\s*$/) { $self->import_error($error_head, 'Name is empty');      next; }
		my $text_short = $text;
		$text_short =~ s/\n//g;			# Խ
		$text_short = $self->string_clip($text_short, $setting->{disp_com_chars_int});
		# Υ
		$ROBJ->tag_escape($text, $name, $_->{email}, $_->{url}, $_->{ip}, $_->{host}, $_->{agent});
		$text =~ s/\n/<br>/g;		# Ԥ br ִ
		# Խ
		&delete_crlf( $name, $_->{email}, $_->{url}, $_->{ip}, $_->{host}, $_->{agent} );
		#-------------------------------------------------------------
		# Ƚ񤭹
		#-------------------------------------------------------------
		my %com;
		$com{diary_pkey} = $pkey;
		$com{tm}         = int($_->{tm}) || $now_tm;
		$com{name}       = $name;
		$com{text}       = $text;
		$com{text_short} = $text_short;
		$com{email}      = $_->{email};
		$com{url}        = $_->{url};
		$com{ip}         = $_->{ip};
		$com{host}       = $_->{host};
		$com{agent}      = $_->{agent};
		# ΥǡΥåǼ
		$com{diary_yyyymmdd} = $diary_yyyymmdd;
		$com{diary_title}    = $diary_title;
		# $com{id} = '';	# id ϻꤵʤ
		if (!defined $_->{enable} || $_->{enable}) { $com{enable}=1; } else { $com{enable}=0; }
		if ($_->{hidden})                          { $com{hidden}=1; } else { $com{hidden}=0; }
		if ($not_enable) { $com{enable}=0; }

		my $r  = $DB->insert("${diary_id}_comment", \%com);
		if ($r) {
			$info{comments_all} += 1;
			$info{comments}     += $com{enable};
		} else {
			$self->import_error($error_head, 'Comment post failed (%s)', "$diary_yyyymmdd - $pkey");
		}
	}

	##############################################################
	# ȥåХåν
	##############################################################
	$error_head = "[trackback][$diary->{yyyymmdd}/$pkey]";
	foreach(@$trackbacks) {
		my $title   = $_->{title};
		my $url     = $_->{url};
		my $excerpt = $_->{excerpt};
		# ʸå
		$ROBJ->tag_escape($title, $excerpt, $_->{blog_name}, $_->{author}, $_->{ip}, $_->{host}, $_->{agent} );
		$url =~ s|[^\w\./:\?\=\&\%\*]||g;		# ʸκ
		if ($title =~ /^\s*$/) { $title = '(no title)'; }
		if ($url   =~ /^\s*$/) { $self->import_error($error_head, 'Not exist from URL'); }
		# ʸʾڤΤ
		$excerpt = $self->string_clip($excerpt, $setting->{tb_recived_int});
		# Խ
		&delete_crlf( $title, $excerpt, $_->{blog_name}, $_->{author}, $url, $_->{ip}, $_->{host}, $_->{agent} );
		#-------------------------------------------------------------
		# ȥåХåν񤭹
		#-------------------------------------------------------------
		my %tb;
		$tb{tm}         = int($_->{tm}) || $now_tm;
		$tb{diary_pkey} = $pkey;
		$tb{title}      = $title;
		$tb{excerpt}    = $excerpt;
		$tb{blog_name}  = $_->{blog_name};
		$tb{author}     = $_->{author};
		$tb{url}        = $url;
		$tb{ip}         = $_->{ip};
		$tb{host}       = $_->{host};
		$tb{agent}      = $_->{agent};
		# ΥǡΥåǼ
		$tb{diary_yyyymmdd} = $diary_yyyymmdd;
		$tb{diary_title}    = $diary_title;

		if (!defined $_->{enable} || $_->{enable}) { $tb{enable}=1; } else { $tb{enable}=0; }
		if ($not_enable) { $tb{enable}=0; }

		my $r  = $DB->insert("${diary_id}_tb", \%tb);
		if ($r) {
			$info{tbs_all} += 1;
			$info{tbs}     += $tb{enable};
		} else {
			$self->import_error($error_head, 'Trackback post failed (%s)', "$diary_yyyymmdd - $pkey");
		}
	}
	#-------------------------------------------------------------
	# ȿȥåХåǡ˵Ͽ
	#-------------------------------------------------------------
	if (%info) {
		$DB->update_match("${diary_id}_diary", \%info, 'pkey', $pkey);
	}

	#-------------------------------------------------------------
	# ॢɻߤΤνϽ
	#-------------------------------------------------------------
	#{
	#	##local ($|) = 1;
	#	## print "import $diary->{yyyymmdd}\n";
	#	##print "X-adiary-Status-Report: import $diary->{yyyymmdd}\n";
	#}
	return 0;
}

###############################################################################
# ǡݡ
###############################################################################
#------------------------------------------------------------------------------
# ݡȼ¹
#------------------------------------------------------------------------------
sub diary_export {
	my ($self, $option) = @_;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};
	my $auth = $ROBJ->{Auth};
	if (! $auth->{ok})             { $ROBJ->message('Not login');                  return 1; }
	if (! $self->{exsits_daybook}) { $ROBJ->message('The daybook does not exist'); return 2; }
	if (! $self->{daybook_admin})  { $ROBJ->message('Operation not permitted');    return 5; }

	#  $option = $form
	my $type  = $option->{type};
	$type =~ s/\W//g;
	if ($type eq '') {
		$ROBJ->message('Please select export type');
		return 11;
	}

	# 
	my $year = $option->{year};
	my $diary_id = $self->{diary_id};
	my %h;
	if ($option->{enable_only}) { $h{flag} = {enable => 1}; }		# ɽǽΤ
	if ($year =~ /^\d\d\d\d$/) {			# YYYY
		$h{min} = {yyyymmdd => "${year}0000"};
		$h{max} = {yyyymmdd => "${year}1300"};
	} elsif ($year =~ /^(\d\d\d\d)\/?(\d?\d$)/) {	# YYYYMM
		my $mon = sprintf("%02d", $2);
		$h{min} = {yyyymmdd => "$1${mon}00"};
		$h{max} = {yyyymmdd => "$1${mon}32"};
	} elsif ($year =~ /^(\d\d\d\d)(\d\d)(\d\d)$/
	      || $year =~ /^(\d\d\d\d)\/(\d?\d)\/(\d?\d)$/) {		# YYYYMMDD
		my $yyyymmdd = sprintf("$1%02d%02d", $2, $3);
		$h{match_int} = {yyyymmdd => $yyyymmdd};
	}
	# ƥ
	my $category = $option->{category};
	if (index($category, '::') >=0) {
		if (substr($category,-2) eq '::') { chop($category); chop($category); }
		$h{match_str} = {category => $category};		# ƥ긡
	} elsif ($category ne '') {
		$h{match_str} = {category_main => $category};		# ƥ긡
	}
	# 
	$h{sort}  = 'yyyymmdd';
	$h{sort2} = 'tm';
	my $logs = $DB->select("${diary_id}_diary", \%h);
	if ($#$logs == -1) {
		$ROBJ->message('No exists diary data');
		return 12;
	}
	# diary object 
	$option->{diary_obj} = $self;
	# call exporter
	if (! $option->{disable_no_output}) {
		return $ROBJ->call( "export/$type", $logs, $option );
	}
	# ɽȤʤɤɤʤ뤿ᡢŪ
	my @backup = ($self->{daybook_admin}, $self->{allow_edit});
	$self->{daybook_admin} = $self->{allow_edit} = 0;
	my $r = $ROBJ->call( "export/$type", $logs, $option );
	($self->{daybook_admin}, $self->{allow_edit}) = @backup;
	return $r;
}

#------------------------------------------------------------------------------
# textʬ䡦ù
#------------------------------------------------------------------------------
sub text_split_for_mt {
	my $self = shift;
	my $h    = shift;

	my $parser = $h->{parser};
	if ($parser eq 'simple' || $parser eq 'simple_p') {
		my $text = $h->{_text};
		my $append;
		if ($text =~ /^(.*?)\n====*\n(.*)/s) {
			$text   = $1;
			$append = $2;
		}
		$h->{body}    = $text;
		$h->{ex_body} = $append;
		$h->{convert_breaks} = 0;
		if ($parser eq 'simple_p') { $h->{convert_breaks} = 1; }
	} else {
		my $text = $h->{text};
		&delete_indent( $text );
		# footnote 󥯤
		my $pkey = $h->{pkey} . 'n';
		$text =~ s/(<a [^>]*?href=)"\/[^"]*?#fn(\d+)"/$1"#fn$pkey$2"/g;
		$text =~ s/(<a [^>]*?name=)"fn(\d+)"/$1"fn$pkey$2"/g;
		# ³ɤࡢ
		my $append;
		if ($text =~ /^(.*?)\n[^\n]*?<!-- Seemore start --><!--.*\n(.*)/s) {
			$text   = $1;
			$append = $2;
			$append =~ s/\n[^\n]*?<!-- Seemore start --><!--//g;
			$append =~ s/\n[^\n]*--><!-- Seemore end -->//g;
		}
		$h->{body}    = $text;
		$h->{ex_body} = $append;
		$h->{convert_breaks} = 0;
	}
	return $h;
}

sub delete_indent {
	# ǥȤν
	my @ary = split("\n", $_[0]);
	if ($ary[0] !~ /^(\s+)/) { return; }
	my $indent = $1;
	foreach(@ary) {
		if (index($_, $indent) != 0) { $indent=''; last; }
	}
	if ($indent eq '') { return; }
	my $len = length($indent);
	foreach(@ary) { $_ = substr($_, $len); }
	$_[0] = join("\n", @ary);
	return 1;
}


###############################################################################
# ֥롼
###############################################################################
sub import_error {
	my $self = shift;
	my $head = shift;
	my $msg  = shift;
	my $ROBJ = $self->{ROBJ};
	if (ref $self->{import_error} ne 'ARRAY') { $self->{import_error}=[]; }
	$msg = $ROBJ->message_translate($msg, @_);
	$ROBJ->tag_escape($msg);
	push(@{ $self->{import_error}}, $head . $msg);
}

sub delete_crlf {
	foreach(@_) {
		$_ =~ s/[\r\n]//g;
	}
}



1;
