use strict;
#------------------------------------------------------------------------------
# ϤƤʵˡץ饰
#                                                   (C)2006 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
package Satsuki::TextParser::TagPlugin::Tag_hatena;
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# 󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;	# ɤ߼Τ
	my $ROBJ  = shift;	# ɤ߼Τ

	my $tags = shift;
	$tags->{'jan'}      = {data => \&hatena_jan};
	$tags->{'hatena:f'} = {data => \&hatena_fotolife};
	$tags->{'graph:id'} = {data => \&hatena_graph};
}

###############################################################################
# 롼
###############################################################################
#------------------------------------------------------------------------------
# ϤƤjan/eanˡ
#------------------------------------------------------------------------------
sub hatena_jan {
	my ($parser_obj, $tag, $cmd, $ary) = @_;

	# jan
	my $jan = shift(@$ary);
	$jan =~ s/[^\d]//g;	# ʸ

	# ⡼ɤɸॵΤб (png/gif/jpg ȽǽΤ)
	my $name = "$cmd:$jan";
	if ($ary->[0] ne '' && $ary->[0] ne 'title') { $name=join(':', @$ary); }
	if ($name eq 'image') {
		$name = "<img src=\"http://d.hatena.ne.jp/images/ean/${jan}_m.gif\" alt=\"$jan\" class=\"ean\">";
	} elsif ($name eq 'barcode') {
		$name = "<img src=\"http://d.hatena.ne.jp/barcode?ean=$jan\" alt=\"$jan\" class=\"barcode\">";
	} elsif (substr($name, 0, 5) eq 'title') {
		$name = substr($name, 6);
	}
	return "<a href=\"http://d.hatena.ne.jp/ean/$jan\"$tag->{class}$tag->{title}>$name</a>";
}

#------------------------------------------------------------------------------
# ϤƤfotolifeˡ
#------------------------------------------------------------------------------
sub hatena_fotolife {
	my ($parser_obj, $tag, $cmd, $ary) = @_;

	my $name = "$cmd:" . join(':', @$ary);
	# f:id:hatenadiary:20041007101545j:image
	# f:id:hatenadiary:20041007101545j:image:small
	# f:id:hatenadiary:20041007101545j:image:w50
	my $id = shift(@$ary);
	$id =~ s/\W//g;
	my $id_key = substr($id, 0, 1);
	my $code = shift(@$ary);
	$code =~ s/[^\d]//g;
	my $yyyymmdd = substr($code, 0, 8);
	my $img_url = "http://f.hatena.ne.jp/images/fotolife/$id_key/$id/$yyyymmdd/$code";
	my $url     = "http://f.hatena.ne.jp/$id/$code";

	# ⡼Ƚ
	my $image = shift(@$ary);
	my $size  = shift(@$ary);
	if ($size eq 'small') { $img_url .= '_m.gif'; } else { $img_url .= '.jpg'; }
	if    ($size =~ /^w(\d+%?)$/) { $size=" width=\"$1\"";  }
	elsif ($size =~ /^h(\d+%?)$/) { $size=" height=\"$1\""; }
	else { $size=''; }

	# target
	my $target = $parser_obj->{image_target};
	if (substr($ary->[0], 0, 6) eq 'target') { $target = substr(shift(@$ary), 7); }
	$target =~ s/\W//g;
	if ($target ne '') { $target=" target=\"$target\""; }

	return "<a href=\"$url\"$tag->{class}$tag->{title}$target><img src=\"$img_url\" alt=\"$name\" class=\"hatena-fotolife\"$size></a>";
}

#------------------------------------------------------------------------------
# ϤƤgraphˡ
#------------------------------------------------------------------------------
# regist = graph:id
sub hatena_graph {
	my ($parser_obj, $tag, $cmd, $ary) = @_;
	my $ROBJ = $parser_obj->{ROBJ};

	my $name = "$cmd:" . join(':', @$ary);
	# graph:id:sample
	# graph:id:sample:ʤν
	# graph:id:sample:ʤν:image
	my $id  = shift(@$ary);
	$id =~ s/\W//g;
	my $url = "http://graph.hatena.ne.jp/$id/";
	#
	my $graph;
	if ($ary->[0] ne '') {
		$name = $graph = shift(@$ary);
		my $jcode = $parser_obj->{jcode} ||= $ROBJ->loadpm('Jcode');
		$jcode->from_to(\$graph, $ROBJ->{System_coding}, 'UTF-8');
		$parser_obj->uri_encode($graph);
		$url .= $graph . '/';
	}
	# ⡼
	if ($graph ne '' && $ary->[0] eq 'image') {
		# target
		my $target = $parser_obj->{image_target};
		if (substr($ary->[1], 0, 6) eq 'target') { $target = substr($ary->[1], 7); }
		$target =~ s/\W//g;
		if ($target ne '') { $target=" target=\"$target\""; }
		return "<a href=\"$url\"$target><img src=\"http://graph.hatena.ne.jp/$id/graph?graphname=$graph\" class=\"hatena-graph-image graph\" alt=\"$name\" title=\"$name\"></a>";
	}
	# ̾
	if ($ary->[0] ne '' && $ary->[0] ne 'title') { $name=join(':', @$ary); }
	if (substr($name,0,5) eq 'title') { $name=substr($name, 6); } 

	# 󥯹
	return "<a href=\"$url\"$tag->{title}$tag->{class}>$name</a>";
}

1;
